locallibrary/catalog/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('', views.index, name='index'),
    path('books/', views.BookListView.as_view(), name='books'),
    path('book/<int:pk>', views.BookDetailView.as_view(), name='book-detail'),
    path('authors/', views.AuthorListView.as_view(), name='authors'),
    path('authors/<int:pk>', views.AuthorDetailView.as_view(), name='author-detail'),
]

locallibrary/locallibrary/urls.py
from django.contrib import admin
from django.urls import path
from django.urls import include
from django.views.generic import RedirectView
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('', RedirectView.as_view(url='catalog/', permanent=True)),
    path('admin/', admin.site.urls),
    path('catalog/', include('catalog.urls')),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

locallibrary/catalog/models.py
from django.db import models
from django.urls import reverse # Used to generate URLs by reversing the URL patterns
import uuid # Required for unique book instances

class Genre(models.Model):
    """Model representing a book genre."""
    name = models.CharField(max_length=200, help_text='Enter a book genre (e.g. Science Fiction)')

    def __str__(self):
        """String for representing the Model object."""
        return self.name

class Book(models.Model):
    """Model representing a book (but not a specific copy of a book)."""
    title = models.CharField(max_length=200)

    # Foreign Key used because book can only have one author, but authors can have multiple books
    # Author as a string rather than object because it hasn't been declared yet in the file
    author = models.ForeignKey('Author', on_delete=models.SET_NULL, null=True)

    summary = models.TextField(max_length=1000, help_text='Enter a brief description of the book')
    isbn = models.CharField('ISBN', max_length=13, help_text='13 Character <a href="https://www.isbn-international.org/content/what-isbn">ISBN number</a>')

    # ManyToManyField used because genre can contain many books. Books can cover many genres.
    # Genres class has already been defined so we can specify the object above.
    genre = models.ManyToManyField(Genre, help_text='Select a genre for this book')

    def __str__(self):
        """String for representing the Model object."""
        return self.title

    def get_absolute_url(self):
        """Returns the url to access a detail record for this book."""
        return reverse('book-detail', args=[str(self.id)])

class Language(models.Model):
    """Model representing a language."""
    name = models.CharField(max_length=200, help_text="Enter the book's language (e.g. English, French, Japanese etc.)")

    def __str__(self):
        """String for representing the Model object."""
        return self.name

class BookInstance(models.Model):
    """Model representing a specific copy of a book (i.e. that can be borrowed from the library)."""
    id = models.UUIDField(primary_key=True, default=uuid.uuid4, help_text='Unique ID for this particular book across whole library')
    book = models.ForeignKey('Book', on_delete=models.SET_NULL, null=True)
    imprint = models.CharField(max_length=200)
    due_back = models.DateField(null=True, blank=True)
    language = models.ForeignKey(Language, on_delete=models.SET_NULL, null=True)

    LOAN_STATUS = (
            ('m', 'Maintenance'),
            ('o', 'On loan'),
            ('a', 'Available'),
            ('r', 'Reserved'),
    )

    status = models.CharField(
            max_length=1,
            choices=LOAN_STATUS,
            blank=True,
            default='m',
            help_text='Book availability',
    )

    class Meta:
        ordering = ['due_back']

    def __str__(self):
        """String for representing the Model object."""
        return f'{self.id} ({self.book.title})'

class Author(models.Model):
    """Model representing an author."""
    first_name = models.CharField(max_length=100)
    last_name = models.CharField(max_length=100)
    date_of_birth = models.DateField(null=True, blank=True)
    date_of_death = models.DateField('Died', null=True, blank=True)

    class Meta:
        ordering = ['last_name', 'first_name']

    def get_absolute_url(self):
        """Returns the url to access a particular author instance."""
        return reverse('author-detail', args=[str(self.id)])

    def __str__(self):
        """String for representing the Model object."""
        return f'{self.last_name} ({self.first_name})'

locallibrary/catalog/views.py
from django.shortcuts import render
from catalog.models import Book, Author, BookInstance, Genre
from django.views import generic

def index(request):
    """View function for home page of site."""

    # Generate counts of some of the main objects
    num_books = Book.objects.all().count()
    num_instances = BookInstance.objects.all().count()

    # Available books (status='a')
    num_instances_available = BookInstance.objects.filter(status__exact='a').count()

    # The 'all()' is implied by default.
    num_authors = Author.objects.count()

    num_classics = Genre.objects.filter(name__contains='Classics').count()
    num_books_of_war = Genre.objects.filter(name__contains='war').count()

    # Number of visits to this view, as counted in the session variable.
    num_visits = request.session.get('num_visits', 0)
    request.session['num_visits'] = num_visits + 1

    context = {
        'num_books': num_books,
        'num_instances': num_instances,
        'num_instances_available': num_instances_available,
        'num_authors': num_authors,
        'num_classics': num_classics,
        'num_books_of_war': num_books_of_war,
        'num_visits': num_visits,
    }

    # Render the HTML template index.html with the data in the context variable
    return render(request, 'index.html', context=context)

class BookListView(generic.ListView):
    model = Book
    paginate_by = 2

class BookDetailView(generic.DetailView):
    model = Book

class AuthorListView(generic.ListView):
    model = Author
    paginate_by = 2

class AuthorDetailView(generic.DetailView):
    model = Author

locallibrary/catalog/templates/base_generic.html
<!DOCTYPE html>
<html lang="en">
  <head>
    {% block title %}<title>Local Library</title>{% endblock %}
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous">
    <!-- Add additional CSS in static file -->
    {% load static %}
    <link rel="stylesheet" href="{% static 'css/styles.css' %}">
  </head>
  <body>
    <div class="container-fluid">
      <div class="row">
	<div class="col-sm-2">
	  {% block sidebar %}
	  <ul class="sidebar-nav">
	    <li><a href="{% url 'index' %}">Home</a></li>
	    <li><a href="{% url 'books' %}">All books</a></li>
	    <li><a href="{% url 'authors' %}">All authors</a></li>
	  </ul>
	  {% endblock %}
	</div>
	<div class="col-sm-10 ">
	  {% block content %}{% endblock %}

	  {% block pagination %}
	  {% if is_paginated %}
	  <div class="pagination">
	    <span class="page-links">
	      {% if page_obj.has_previous %}
	      <a href="{{ request.path }}?page={{ page_obj.previous_page_number }}">previous</a>
	      {% endif %}
	      <span class="page-current">
		Page {{ page_obj.number }} of {{ page_obj.paginator.num_pages }}.
	      </span>
	      {% if page_obj.has_next  %}
	      <a href="{{ request.path }}?page={{ page_obj.next_page_number }}">next</a>
	      {% endif %}
	    </span>
	  </div>
	  {% endif %}
	  {% endblock %}
	</div>
      </div>
    </div>
  </body>
</html>

locallibrary/catalog/templates/catalog/author_detail.html
{% extends "base_generic.html" %}

{% block content %}
<h1>Author: {{ author }}</h1>

<p><strong>Date of birth:</strong> {{ author.date_of_birth }}</p>
<p><strong>Died:</strong> {{ author.died }}</p> 

<div style="margin-left:20px;margin-top:20px">
  <h4>Books</h4>

  {% for book in author.book_set.all %}
  <hr>
  <p><a href="{% url 'book-detail' book.pk %}">{{ book }}</a></p>
  {% endfor %}
</div>
{% endblock %}

locallibrary/catalog/templates/catalog/author_list.html
{% extends "base_generic.html" %}

{% block content %}
  <h1>Author List</h1>
  {% if author_list %}
  <ul>
    {% for author in author_list %}
      <li>
	<a href="{{ author.get_absolute_url }}">{{ author }}</a>
      </li>
    {% endfor %}
  </ul>
  {% else %}
    <p>There are no authors in the library.</p>
  {% endif %}
{% endblock %}

locallibrary/catalog/templates/catalog/book_detail.html
{% extends "base_generic.html" %}

{% block content %}
  <h1>Title: {{ book.title }}</h1>

  <p><strong>Author:</strong> <a href="{% url 'author-detail' book.author.pk %}">{{ book.author }}</a></p> <!-- author detail link not yet defined -->
  <p></strong>Summary:</strong> {{ book.summary }}</p>
  <p></strong>ISBN:</strong> {{ book.isbn }}</p>
  <p></strong>Language:</strong> {{ book.language }}</p>
  <p></strong>Genre:</strong> {{ book.genre.all|join:", " }}</p>

  <div style="margin-left:20px;margin-top:20px">
    <h4>Copies</h4>

    {% for copy in book.bookinstance_set.all %}
      <hr>
      <p class="{% if copy.status == 'a' %}text-success{% elif copy.status == 'm' %}text-danger{% else %}text-warning{% endif %}">
	{{ copy.get_status_display }}
      </p>
      {% if copy.status != 'a' %}
	<p><strong>Due to be returned:</strong> {{ copy.due_back }}</p>
      {% endif %}
      <p><strong>Imprint:</strong> {{ copy.imprint }}</p>
      <p class="text-muted"><strong>Id:</strong> {{ copy.id }}</p>
    {% endfor %}
  </div>
{% endblock %}

locallibrary/catalog/templates/catalog/book_list.html
{% extends "base_generic.html" %}

{% block content %}
  <h1>Book List</h1>
  {% if book_list %}
  <ul>
    {% for book in book_list %}
      <li>
	<a href="{{ book.get_absolute_url }}">{{ book.title }}</a> ({{book.author}})
      </li>
    {% endfor %}
  </ul>
  {% else %}
    <p>There are no books in the library.</p>
  {% endif %}
{% endblock %}

locallibrary/catalog/templates/index.html
{% extends "base_generic.html" %}

{% block title %}
<title>Django Tutorial - Local Library Home</title>
{% endblock %}

{% block content %}
<h1>Local Library Home</h1>
<p>Welcome to LocalLibrary, a website developed by <em>Mozilla Developer Network</em>!</p>
<h2>Dynamic content</h2>
<p>The library has the following record counts:</p>
<ul>
  <li><strong>Books:</strong> {{ num_books }}</li>
  <li><strong>Copies:</strong> {{ num_instances }}</li>
  <li><strong>Copies available:</strong> {{ num_instances_available }}</li>
  <li><strong>Authors:</strong> {{ num_authors }}</li>
  <li><strong>Classics:</strong> {{ num_classics }}</li>
  <li><strong>Books of war:</strong> {{ num_books_of_war }}</li>
</ul>

<p> You have visited this page {{ num_visits }}{% if num_visits == 1 %} time{% else %} times{% endif %}.</p>
{% endblock %}